////////////////////////////////////////////////////
// label functions /////////////////////////////////

#include "labels.h"


Program::Program()
{
  mLine = -1;
  mFlag = CLEAN;
  mPos  = 0;
  mCode = "";
  mLabel= "";
  mNComp = 0;
}
Program::~Program()
{
  mList.Delete();
}
int Program::process()
{
  if(getFlag()==COMMENT)    return 0;
  if(getFlag()==PRECOMP)    return 0;
  if(getFlag()==EXPRESSION) return 0;
  bool label = false;
  if(getFlag()==JUMPLABEL) label = true;
  
  TString L = getCodeClean();
  L.ReplaceAll(","," ");
  L.ReplaceAll("\t"," ");
  L.ReplaceAll("."," ");
  L.ReplaceAll("("," ");
  L.ReplaceAll(")"," ");
  L.ReplaceAll("["," [ ");
  L.ReplaceAll("]"," ] ");
  L.ReplaceAll("="," = ");
  L.ReplaceAll("+"," + ");
  L.ReplaceAll("-"," - ");
  L.ReplaceAll("*"," * ");
  L.ReplaceAll("/"," / ");
  do
  {
    int stop = L.Index(" ")-1;
    if(stop<0) stop = L.Length()-1;
    TString T = L(0,stop+1);
    T = getCodeClean((char*)T.Data()); 
    if(label) 
    {
      mLabel = T;
      label = false;
    }
    else
    {
      mList.Add(new TObjString(T));
    }   
    L=getCodeClean((char*)(L(stop+1,L.Length())).Data()); 
  } while(L.Length()>0);
    
  return 0;
}
char* Program::getCodeClean(char* LINE)
{
  TString L;
  if(!LINE) L=mCode; else L=LINE;
  L.ReplaceAll("\t"," ");
  while(L.Length()>0 && L.BeginsWith(" ")) L = L(1,L.Length()-1);
  if(L.Length()==0) return NULL;
  int i = L.Index(";");
  if(i>0) L = L(0,i);
  while(L.Length()>0 && L.EndsWith(" ")) L = L(0,L.Length()-1);
  if(L.Length()==0) return NULL;
  return (char*)L.Data();
}
char* Program::getCode(bool removeComment)
{
  if(!removeComment) return (char*) mCode.Data();
  TString L=mCode;;
  int i = L.Index(";");
  if(i>0) L = L(0,i);
  return (char*)L.Data();	
}
