// ****************************************************************************
// Copyright (C) 2004  Alexandre Suaide
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// The Crate Controler Wiener-CC32 is not authorized for use as
// critical component in life support systems without the express
// written approval of ARW Elektronik Germany.
//
// Maintainer(s): Alexandre Suaide (suaide@if.usp.br)
//
// ****************************************************************************
#ifndef __CAMAC_DEFINES__
#define __CAMAC_DEFINES__

  // Some CAMAC specific flags  
  #define CC_BUSY       1
  #define CC_READY      0
  #define CCRESET      16
  #define CCREAD16     17
  #define CCREAD24     18
  #define CCREADV16    19
  #define CCWRITE16    20
  #define CCWRITE24    21
  #define CCDMAI16     22
  #define CCWAITLAM    23
  #define CCREADEVNT   24
  #define CCMAXSIZE    25
  #define CCLOADEH     26
  #define CCGETLOST    27
  #define CCSETCRATE   28
  #define CCGETUSED    29
  #define CCGETBUF     30
  #define CCLOADEHPLUS 31
  #define NAFGEN(n,a,f) (((f << 0x05) | n) | (a << 0x0A))

  #define BUFFER_SIZE 262144
  #define BUFFER_SIZE_ARRAY 270000
  #define MAX_BUFFER 4096
  #define MIN_BUFFER_SIZE 64
  #define MAX_BUFFER_SIZE 4096
  #define MAX_EVENT_SIZE 1024
  #define INSTR_SIZE  8192
  #define ENABLE  0x0c03
  #define DISABLE 0x0d03
  #define MAX_CRATES 4
  
  // these are the registers for the adacPlus compiler
  #define MAXBRUR 100
  #define NREGISTERS 3
  #define MAXREGISTERS 10
  
#endif
